--- /dev/null
+++ b/zipl/boot/stage2dump.h
@@ -0,0 +1,127 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Common dump functions
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#ifndef STAGE2DUMP_H
+#define STAGE2DUMP_H
+
+#include "libc.h"
+#include "s390.h"
+
+#define IPL_SC	*((struct subchannel_id *) &S390_lowcore.subchannel_id)
+
+/*
+ * zipl parameters passed at tail of dump tools
+ */
+struct stage2dump_parm_tail {
+	char		reserved[6];
+	uint16_t	mvdump_force;
+	uint64_t	mem_upper_limit;
+} __packed;
+
+extern struct stage2dump_parm_tail parm_tail
+	__attribute__ ((section(".stage2dump.tail")));
+
+/*
+ * Load 4 bytes from addr
+ */
+static inline unsigned int load(unsigned long addr)
+{
+	unsigned int val;
+
+	asm volatile(
+		"	l	%0,0(%1)\n"
+		: "=d" (val) : "d" (addr) : "cc");
+	return val;
+}
+
+/*
+ * S390 dump format defines
+ */
+#define DF_S390_MAGIC		0xa8190173618f23fdULL
+#define DF_S390_HDR_SIZE	0x1000
+#define DF_S390_EM_SIZE		16
+#define DF_S390_EM_MAGIC	0x44554d505f454e44ULL
+#define DF_S390_CPU_MAX		512
+#define DF_S390_MAGIC_BLK_ECKD	3
+
+/*
+ * Architecture of dumped system
+ */
+enum df_s390_arch {
+	DF_S390_ARCH_32	= 1,
+	DF_S390_ARCH_64	= 2,
+};
+
+/*
+ * s390 dump header format
+ */
+struct df_s390_hdr {
+	uint64_t	magic;				/* 0x000 */
+	uint32_t	version;			/* 0x008 */
+	uint32_t	hdr_size;			/* 0x00c */
+	uint32_t	dump_level;			/* 0x010 */
+	uint32_t	page_size;			/* 0x014 */
+	uint64_t	mem_size;			/* 0x018 */
+	uint64_t	mem_start;			/* 0x020 */
+	uint64_t	mem_end;			/* 0x028 */
+	uint32_t	num_pages;			/* 0x030 */
+	uint32_t	pad;				/* 0x034 */
+	uint64_t	tod;				/* 0x038 */
+	uint64_t	cpu_id;				/* 0x040 */
+	uint32_t	arch;				/* 0x048 */
+	uint32_t	volnr;				/* 0x04c */
+	uint32_t	build_arch;			/* 0x050 */
+	uint64_t	mem_size_real;			/* 0x054 */
+	uint8_t		mvdump;				/* 0x05c */
+	uint16_t	cpu_cnt;			/* 0x05d */
+	uint16_t	real_cpu_cnt;			/* 0x05f */
+	uint8_t		end_pad1[0x200-0x061];		/* 0x061 */
+	uint64_t	mvdump_sign;			/* 0x200 */
+	uint64_t	mvdump_zipl_time;		/* 0x208 */
+	uint8_t		end_pad2[0x800-0x210];		/* 0x210 */
+	uint32_t	lc_vec[DF_S390_CPU_MAX];	/* 0x800 */
+} __packed __aligned(16);
+
+/*
+ *  End marker: Should be at the end of every valid s390 crash dump
+ */
+struct df_s390_em {
+	uint64_t	magic;
+	uint64_t	tod;
+} __packed __aligned(16);
+
+/*
+ * Linker script defined symbols
+ */
+extern char __eckd2mvdump_parm_start[];
+extern char __stage2_desc[];
+
+/*
+ * Dump common globals
+ */
+extern struct df_s390_hdr *dump_hdr;
+
+/*
+ * Common functions
+ */
+void create_ida_list(unsigned long *list, int len, unsigned long addr,
+		     unsigned long zero_page);
+void init_progress_print(void);
+void progress_print(unsigned long addr);
+void df_s390_em_page_init(unsigned long page);
+void pgm_check_handler(void);
+
+/*
+ * Dump tool backend functions
+ */
+void dt_device_parm_setup(void);
+void dt_device_enable(void);
+void dt_dump_mem(void);
+
+#endif /* STAGE2DUMP_H */
--- /dev/null
+++ b/zipl/boot/stage3.c
@@ -0,0 +1,298 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Main program for stage3 bootloader.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#include "stage3.h"
+#include "libc.h"
+#include "s390.h"
+
+/*
+ * 48 Byte dummy space for external symbols
+ * _parm_addr;    address of parmline
+ * _initrd_addr;  address of initrd
+ * _initrd_len;   length of initrd
+ * _load_psw;     load psw of kernel
+ * _extra_parm;   use extra parm line mechanism?
+ * stage3_flags;  flags (e.g. STAGE3_FLAG_KDUMP)
+ *
+ * needed to blow up the binary and leave room
+ */
+__attribute__ ((section(".text.dummy"))) void _dummy(void)
+{
+		asm volatile(
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		".long 0x00000000\n"
+		);
+}
+
+static unsigned char ebc_037[256] = {
+/* 0x00  NUL   SOH   STX   ETX  *SEL    HT  *RNL   DEL */
+	0x00, 0x01, 0x02, 0x03, 0x07, 0x09, 0x07, 0x7F,
+/* 0x08  -GE  -SPS  -RPT    VT    FF    CR    SO    SI */
+	0x07, 0x07, 0x07, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+/* 0x10  DLE   DC1   DC2   DC3  -RES   -NL    BS  -POC
+                                -ENP  ->LF             */
+	0x10, 0x11, 0x12, 0x13, 0x07, 0x0A, 0x08, 0x07,
+/* 0x18  CAN    EM  -UBS  -CU1  -IFS  -IGS  -IRS  -ITB
+                                                  -IUS */
+	0x18, 0x19, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x20  -DS  -SOS    FS  -WUS  -BYP    LF   ETB   ESC
+                                -INP                   */
+	0x07, 0x07, 0x1C, 0x07, 0x07, 0x0A, 0x17, 0x1B,
+/* 0x28  -SA  -SFE   -SM  -CSP  -MFA   ENQ   ACK   BEL
+                     -SW                               */
+	0x07, 0x07, 0x07, 0x07, 0x07, 0x05, 0x06, 0x07,
+/* 0x30 ----  ----   SYN   -IR   -PP  -TRN  -NBS   EOT */
+	0x07, 0x07, 0x16, 0x07, 0x07, 0x07, 0x07, 0x04,
+/* 0x38 -SBS   -IT  -RFF  -CU3   DC4   NAK  ----   SUB */
+	0x07, 0x07, 0x07, 0x07, 0x14, 0x15, 0x07, 0x1A,
+/* 0x40   SP   RSP           ä              ----       */
+	0x20, 0xFF, 0x83, 0x84, 0x85, 0xA0, 0x07, 0x86,
+/* 0x48                      .     <     (     +     | */
+	0x87, 0xA4, 0x9B, 0x2E, 0x3C, 0x28, 0x2B, 0x7C,
+/* 0x50    &                                      ---- */
+	0x26, 0x82, 0x88, 0x89, 0x8A, 0xA1, 0x8C, 0x07,
+/* 0x58          ß     !     $     *     )     ;       */
+	0x8D, 0xE1, 0x21, 0x24, 0x2A, 0x29, 0x3B, 0xAA,
+/* 0x60    -     /  ----     Ä  ----  ----  ----       */
+	0x2D, 0x2F, 0x07, 0x8E, 0x07, 0x07, 0x07, 0x8F,
+/* 0x68             ----     ,     %     _     >     ? */
+	0x80, 0xA5, 0x07, 0x2C, 0x25, 0x5F, 0x3E, 0x3F,
+/* 0x70  ---        ----  ----  ----  ----  ----  ---- */
+	0x07, 0x90, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x78    *     `     :     #     @     '     =     " */
+	0x70, 0x60, 0x3A, 0x23, 0x40, 0x27, 0x3D, 0x22,
+/* 0x80    *     a     b     c     d     e     f     g */
+	0x07, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
+/* 0x88    h     i              ----  ----  ----       */
+	0x68, 0x69, 0xAE, 0xAF, 0x07, 0x07, 0x07, 0xF1,
+/* 0x90    °     j     k     l     m     n     o     p */
+	0xF8, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 0x70,
+/* 0x98    q     r                    ----        ---- */
+	0x71, 0x72, 0xA6, 0xA7, 0x91, 0x07, 0x92, 0x07,
+/* 0xA0          ~     s     t     u     v     w     x */
+	0xE6, 0x7E, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
+/* 0xA8    y     z              ----  ----  ----  ---- */
+	0x79, 0x7A, 0xAD, 0xAB, 0x07, 0x07, 0x07, 0x07,
+/* 0xB0    ^                    ----     §  ----       */
+	0x5E, 0x9C, 0x9D, 0xFA, 0x07, 0x07, 0x07, 0xAC,
+/* 0xB8       ----     [     ]  ----  ----  ----  ---- */
+	0xAB, 0x07, 0x5B, 0x5D, 0x07, 0x07, 0x07, 0x07,
+/* 0xC0    {     A     B     C     D     E     F     G */
+	0x7B, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
+/* 0xC8    H     I  ----           ö              ---- */
+	0x48, 0x49, 0x07, 0x93, 0x94, 0x95, 0xA2, 0x07,
+/* 0xD0    }     J     K     L     M     N     O     P */
+	0x7D, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50,
+/* 0xD8    Q     R  ----           ü                   */
+	0x51, 0x52, 0x07, 0x96, 0x81, 0x97, 0xA3, 0x98,
+/* 0xE0    \           S     T     U     V     W     X */
+	0x5C, 0xF6, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
+/* 0xE8    Y     Z        ----     Ö  ----  ----  ---- */
+	0x59, 0x5A, 0xFD, 0x07, 0x99, 0x07, 0x07, 0x07,
+/* 0xF0    0     1     2     3     4     5     6     7 */
+	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
+/* 0xF8    8     9  ----  ----     Ü  ----  ----  ---- */
+	0x38, 0x39, 0x07, 0x07, 0x9A, 0x07, 0x07, 0x07
+};
+
+static unsigned char ebc_500[256] = {
+/* 0x00  NUL   SOH   STX   ETX  *SEL    HT  *RNL   DEL */
+	0x00, 0x01, 0x02, 0x03, 0x07, 0x09, 0x07, 0x7F,
+/* 0x08  -GE  -SPS  -RPT    VT    FF    CR    SO    SI */
+	0x07, 0x07, 0x07, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
+/* 0x10  DLE   DC1   DC2   DC3  -RES   -NL    BS  -POC
+                                -ENP  ->LF             */
+	0x10, 0x11, 0x12, 0x13, 0x07, 0x0A, 0x08, 0x07,
+/* 0x18  CAN    EM  -UBS  -CU1  -IFS  -IGS  -IRS  -ITB
+                                                  -IUS */
+	0x18, 0x19, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x20  -DS  -SOS    FS  -WUS  -BYP    LF   ETB   ESC
+                                -INP                   */
+	0x07, 0x07, 0x1C, 0x07, 0x07, 0x0A, 0x17, 0x1B,
+/* 0x28  -SA  -SFE   -SM  -CSP  -MFA   ENQ   ACK   BEL
+                     -SW                               */
+	0x07, 0x07, 0x07, 0x07, 0x07, 0x05, 0x06, 0x07,
+/* 0x30 ----  ----   SYN   -IR   -PP  -TRN  -NBS   EOT */
+	0x07, 0x07, 0x16, 0x07, 0x07, 0x07, 0x07, 0x04,
+/* 0x38 -SBS   -IT  -RFF  -CU3   DC4   NAK  ----   SUB */
+	0x07, 0x07, 0x07, 0x07, 0x14, 0x15, 0x07, 0x1A,
+/* 0x40   SP   RSP           ä              ----       */
+	0x20, 0xFF, 0x83, 0x84, 0x85, 0xA0, 0x07, 0x86,
+/* 0x48                      .     <     (     +     | */
+	0x87, 0xA4, 0x9B, 0x2E, 0x3C, 0x28, 0x2B, 0x7C,
+/* 0x50    &                                      ---- */
+	0x26, 0x82, 0x88, 0x89, 0x8A, 0xA1, 0x8C, 0x07,
+/* 0x58          ß     !     $     *     )     ;       */
+	0x8D, 0xE1, 0x21, 0x24, 0x2A, 0x29, 0x3B, 0xAA,
+/* 0x60    -     /  ----     Ä  ----  ----  ----       */
+	0x2D, 0x2F, 0x07, 0x8E, 0x07, 0x07, 0x07, 0x8F,
+/* 0x68             ----     ,     %     _     >     ? */
+	0x80, 0xA5, 0x07, 0x2C, 0x25, 0x5F, 0x3E, 0x3F,
+/* 0x70  ---        ----  ----  ----  ----  ----  ---- */
+	0x07, 0x90, 0x07, 0x07, 0x07, 0x07, 0x07, 0x07,
+/* 0x78    *     `     :     #     @     '     =     " */
+	0x70, 0x60, 0x3A, 0x23, 0x40, 0x27, 0x3D, 0x22,
+/* 0x80    *     a     b     c     d     e     f     g */
+	0x07, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66, 0x67,
+/* 0x88    h     i              ----  ----  ----       */
+	0x68, 0x69, 0xAE, 0xAF, 0x07, 0x07, 0x07, 0xF1,
+/* 0x90    °     j     k     l     m     n     o     p */
+	0xF8, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E, 0x6F, 0x70,
+/* 0x98    q     r                    ----        ---- */
+	0x71, 0x72, 0xA6, 0xA7, 0x91, 0x07, 0x92, 0x07,
+/* 0xA0          ~     s     t     u     v     w     x */
+	0xE6, 0x7E, 0x73, 0x74, 0x75, 0x76, 0x77, 0x78,
+/* 0xA8    y     z              ----  ----  ----  ---- */
+	0x79, 0x7A, 0xAD, 0xAB, 0x07, 0x07, 0x07, 0x07,
+/* 0xB0    ^                    ----     §  ----       */
+	0x5E, 0x9C, 0x9D, 0xFA, 0x07, 0x07, 0x07, 0xAC,
+/* 0xB8       ----     [     ]  ----  ----  ----  ---- */
+	0xAB, 0x07, 0x5B, 0x5D, 0x07, 0x07, 0x07, 0x07,
+/* 0xC0    {     A     B     C     D     E     F     G */
+	0x7B, 0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47,
+/* 0xC8    H     I  ----           ö              ---- */
+	0x48, 0x49, 0x07, 0x93, 0x94, 0x95, 0xA2, 0x07,
+/* 0xD0    }     J     K     L     M     N     O     P */
+	0x7D, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50,
+/* 0xD8    Q     R  ----           ü                   */
+	0x51, 0x52, 0x07, 0x96, 0x81, 0x97, 0xA3, 0x98,
+/* 0xE0    \           S     T     U     V     W     X */
+	0x5C, 0xF6, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
+/* 0xE8    Y     Z        ----     Ö  ----  ----  ---- */
+	0x59, 0x5A, 0xFD, 0x07, 0x99, 0x07, 0x07, 0x07,
+/* 0xF0    0     1     2     3     4     5     6     7 */
+	0x30, 0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37,
+/* 0xF8    8     9  ----  ----     Ü  ----  ----  ---- */
+	0x38, 0x39, 0x07, 0x07, 0x9A, 0x07, 0x07, 0x07
+};
+
+static void ebcdic_to_ascii(unsigned char *target, unsigned char *source,
+		     unsigned int l)
+{
+	unsigned char *ebc;
+	unsigned int i;
+
+	ebc = is_zvm() ? ebc_037 : ebc_500;
+	for (i = 0; i < l; i++)
+			target[i] = ebc[source[i]];
+}
+
+static void
+start_kernel(void)
+{
+	struct psw_t *psw = &S390_lowcore.program_new_psw;
+	unsigned long addr, code;
+
+	/* Setup program check handler */
+	psw->mask = 0x000000180000000ULL;
+	code = 1;
+
+	asm volatile(
+		/* Setup program check handler */
+		"       larl    %[addr],.no_diag308\n"
+		"       stg     %[addr],8(%[psw])\n"
+		"       diag    %[code],%[code],0x308\n"
+		".no_diag308:\n"
+		"       sam31\n"
+		"       sr      %r1,%r1\n"
+		"       sr      %r2,%r2\n"
+		"       sigp    %r1,%r2,0x12\n"
+		"       lpsw    0\n"
+		: [addr] "=&d" (addr),
+		  [code] "+&d" (code)
+		: [psw] "a" (psw) );
+}
+
+void start(void)
+{
+	unsigned int subchannel_id;
+	unsigned char *cextra = (unsigned char *)COMMAND_LINE_EXTRA;
+	unsigned char *command_line =  (unsigned char *)COMMAND_LINE;
+	unsigned int begin = 0, end = 0, length = 0;
+
+	/* store subchannel ID into low core and into new kernel space */
+	subchannel_id = S390_lowcore.subchannel_id;
+	*(unsigned int *)__LC_IPLDEV = subchannel_id;
+	*(unsigned int *)IPL_DEVICE = subchannel_id;
+
+	/* if valid command line is given, copy it into new kernel space */
+	if (_parm_addr != UNSPECIFIED_ADDRESS) {
+		memcpy((void *)COMMAND_LINE,
+		       (void *)(unsigned long *)_parm_addr, COMMAND_LINE_SIZE);
+		/* terminate \0 */
+		*(char *)(COMMAND_LINE + COMMAND_LINE_SIZE - 1) = 0;
+	}
+
+	/* convert extra parameter to ascii */
+	if (!_extra_parm || !*cextra)
+		goto noextra;
+
+	/* Handle extra kernel parameters specified in DASD boot menu. */
+	ebcdic_to_ascii(cextra, cextra, COMMAND_LINE_SIZE);
+
+	/* remove leading whitespace */
+	while (begin <= COMMAND_LINE_SIZE && cextra[begin] == 0x20)
+		begin++;
+
+	/* determine length of extra parameter */
+	while (length <= COMMAND_LINE_SIZE && cextra[length] != 0)
+		length++;
+
+	/* find end of original parm line */
+	while (command_line[end] != 0 && command_line[end] != 0)
+		end++;
+
+	/*
+	 * if extra parm string starts with '=' replace original string,
+	 * else append
+	 */
+	if (cextra[begin] == 0x3d) {
+		memcpy((void *)COMMAND_LINE, (void *)(cextra + begin),
+		       length);
+	} else {
+		/* check if length is within max value */
+		length = (end + 1 + length <= COMMAND_LINE_SIZE) ? length :
+			(COMMAND_LINE_SIZE - end - 1);
+		/* add blank */
+		command_line[end] = 0x20;
+		end++;
+		/* append string */
+		memcpy((void *)(command_line + end),
+		       (void *)(cextra + begin), length);
+		/* terminate 0 */
+		command_line[end + length] = 0;
+	}
+
+noextra:
+	/* copy initrd start address and size intop new kernle space */
+	*(unsigned long long *)INITRD_START = _initrd_addr;
+	*(unsigned long long *)INITRD_SIZE = _initrd_len;
+
+	/* store address of new kernel to 0 to be able to start it */
+	*(unsigned long long *)0 = _load_psw;
+
+	kdump_stage3();
+
+	/* start new kernel */
+	start_kernel();
+}
+
+void panic_notify(unsigned long UNUSED(rc))
+{
+}
--- /dev/null
+++ b/zipl/boot/stage3.h
@@ -0,0 +1,38 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Main program for stage3 bootloader.
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Stefan Haberland <stefan.haberland@de.ibm.com>
+ */
+
+#ifndef STAGE3_H
+#define STAGE3_H
+
+#include "libc.h"
+#include "s390.h"
+
+#define IPL_DEVICE		 0x10404
+#define INITRD_START		 0x10408
+#define INITRD_SIZE		 0x10410
+#define OLDMEM_BASE		 0x10418
+#define OLDMEM_SIZE		 0x10420
+#define COMMAND_LINE		 0x10480
+#define COMMAND_LINE_SIZE	 896
+#define COMMAND_LINE_EXTRA	 (0xA000-0x400)
+
+#define STAGE3_FLAG_SCSI	 0x0001000000000000ULL
+#define STAGE3_FLAG_KDUMP	 0x0002000000000000ULL
+
+#define UNSPECIFIED_ADDRESS		-1ULL
+
+extern unsigned long long _parm_addr;   /* address of parmline */
+extern unsigned long long _initrd_addr; /* address of initrd */
+extern unsigned long long _initrd_len;  /* length of initrd */
+extern unsigned long long _load_psw;    /*  load psw of kernel */
+extern unsigned long long _extra_parm;  /* use extra parm line mechanism? */
+extern unsigned long long stage3_flags; /*  flags (e.g. STAGE3_FLAG_KDUMP) */
+extern void kdump_stage3();
+
+#endif /* STAGE3_H */
--- /dev/null
+++ b/zipl/boot/stage3.lds
@@ -0,0 +1,45 @@
+/*
+ * Memory layout for stage 3
+ */
+
+SECTIONS
+{
+  . = 0x0;
+
+  . = 0x7000;
+  __heap_start = .;
+  . = 0xa000;
+  __heap_stop = .;
+
+  . = 0xa000;
+  _parm_addr = .;
+  . = 0xa008;
+  _initrd_addr = .;
+  . = 0xa010;
+  _initrd_len = .;
+  . = 0xa018;
+  _load_psw = .;
+  . = 0xa020;
+  _extra_parm = .;
+  . = 0xa028;
+  stage3_flags =.;
+
+  . = 0xa000;
+  .text.dummy : { *(.text.dummy) }
+
+  . = 0xa050;
+  .text.start : { *(.text.start) }
+  .text : { *(.text) }
+  __ex_table_start = .;
+  .ex_table : { *(.ex_table) }
+  __ex_table_stop = .;
+  .eh_frame : { *(.eh_frame) }
+
+  . = 0xc000;
+  __bss_start = .;
+  .bss : { *(.bss) }
+  __bss_stop = .;
+  .rodata : {*(.rodata) }
+  .data : { *(.data) }
+
+}
--- a/zipl/boot/tape0.S
+++ b/zipl/boot/tape0.S
@@ -11,6 +11,8 @@ IPL_OFF			= 0x4000		# temporary kernel l
 COMMAND_LINE_SIZE	= 896			# max command line length
 KERNEL_OFF		= 0x10000		# kernel start code offset
 						# relative to image start
+__LC_IO_NEW_PSW         = 0x1f0			# IO New PSW addr
+
 
 # Parameter address offsets
 
@@ -50,12 +52,11 @@ _start:
 	.long 0x000a0000,0x00000060		# svc new psw
 	.long 0x000a0000,0x00000068		# program check new psw
 	.long 0x000a0000,0x00000070		# machine check new psw
-	.long 0x00080000,0x80000000+.Lioint	# io new psw
 
 
 # IPL parameter area
 
-	.org 0x100
+	.org 0x200
 _parm_addr:
 	.quad PARMFILE_ADDR			# parmfile load address
 _initrd_addr:
@@ -178,6 +179,23 @@ _load_psw:
 
 iplstart:
 	stm   %r0,%r15,.Lvmparamtemp		# store vm params for later use
+	basr    %r13,0
+0:
+	la      %r7,2                           #/* First try code 2: */
+	la      %r6,0                           #/* 64 bit psws are restored */
+	sigp    %r7,%r6,0x12                    #/* Switch to 64 bit */
+	bc      8,.Lswitched_64-0b(%r13)        #/* Accepted ? */
+	la      %r7,1                           #/* Failed - try code 1 */
+	sigp    %r7,%r6,0x12                    #/* Switch to 64 bit */
+.Lswitched_64:
+	sam64                                   #/* Switch to 64 bit addr mode */
+	basr    %r13,0
+1:
+	mvc    __LC_IO_NEW_PSW(16),4f-1b(%r13)    # set i/o new ps
+	b      .Lafterpsw
+4:
+	.long  0x00000001,0x80000000,0x00000000,0x00000000+.Lioint    # io new psw
+.Lafterpsw:
 	l     %r1,0xb8			 	# load rest of loader/TM
 	la    %r2,IPL_BS
 	bas   %r14,.Lloader
--- /dev/null
+++ b/zipl/boot/tape2dump.c
@@ -0,0 +1,214 @@
+/*
+ * zipl - zSeries Initial Program Loader tool
+ *
+ * Dump tool for channel-attached tape devices
+ *
+ * Copyright IBM Corp. 2013
+ * Author(s): Michael Holzheu <holzheu@linux.vnet.ibm.com>
+ */
+
+#include "stage2dump.h"
+#include "libc.h"
+#include "cio.h"
+#include "error.h"
+
+#define BLK_SIZE	0x8000 /* We write 32 KB at a time */
+#define ETAPE_WRITE	0x0003 /* Error code for failed write */
+
+#define WRITE_CMD	0x01	/* Write block */
+#define SENSE_OVERRUN	0x04	/* Sense */
+#define WRITETAPEMARK	0x1f	/* Write Tape Mark */
+#define READ_DEV_CHAR	0x64	/* Read device characteristics */
+#define LOAD_DISPLAY	0x9f	/* Load tape display */
+#define MODE_SET_DB	0xdb	/* Mode set */
+
+/*
+ * Tape head code (PSW and two CCWs to load dump tool)
+ */
+struct tape_head {
+	uint64_t	psw;
+	uint64_t	ccw1;
+	uint64_t	ccw2;
+} __packed;
+
+struct tape_head tape_head __attribute__((section(".stage2.head"))) = {
+	.psw	= 0x0008000080002018ULL, /* Start code at 0x2018 */
+	.ccw1	= 0x0700000060000001ULL, /* Rewind ccw */
+	.ccw2	= 0x0200200020003000ULL, /* CCW to load dump tool to 0x2000 */
+};
+
+/*
+ * ORB, CCW, and CCW data
+ */
+static struct orb orb = {
+	.fmt	= 1,		/* Use format 1 CCWs */
+	.c64	= 1,		/* Use IDAs */
+	.lpm	= 0xff,		/* Logical path mask */
+};
+static char ccw_data[64] __aligned(8);
+static uint32_t mode_set_byte = 0x08000000;
+static struct irb irb;
+
+/*
+ * CCW program for writes
+ */
+static struct {
+	struct ccw1	compress;
+	struct ccw1	write;
+	unsigned long	ida_list[BLK_SIZE / PAGE_SIZE];
+} ccw_program __aligned(8);
+
+/*
+ * Get device characteristics (nothing to do for tape)
+ */
+void dt_device_parm_setup(void)
+{
+}
+
+/*
+ * Enable tape device
+ */
+void dt_device_enable(void)
+{
+	io_irq_enable();
+	set_device(IPL_SC, ENABLED);
+}
+
+/*
+ * Initialize CCW
+ */
+static void ccw_init(struct ccw1 *ccw, uint8_t code, uint8_t flags,
+		     uint16_t count, void *cda)
+{
+	ccw->cmd_code = code;
+	ccw->flags = flags;
+	ccw->count = count;
+	ccw->cda = __pa32(cda);
+}
+
+/*
+ * Execute CCW
+ */
+static void start_ccw(uint8_t code, uint8_t flags, uint16_t count, void *cda)
+{
+	static struct ccw1 ccw;
+
+	ccw_init(&ccw, code, flags, count, cda);
+	orb.cpa = __pa32(&ccw);
+	start_io(IPL_SC, &irb, &orb);
+}
+
+/*
+ * Read tape device characteristics to find out if IDRC compression can be used
+ */
+static void setup_idrc_compression(void)
+{
+	uint16_t type;
+
+	start_ccw(READ_DEV_CHAR, 0x0, 0x40, ccw_data);
+
+	memcpy(&type, &ccw_data[3], sizeof(type));
+	switch (type) {
+	case 0x3490:
+	case 0x3590: // XXX 3592
+		ccw_init(&ccw_program.compress, MODE_SET_DB, CCW_FLAG_CC, 0x1,
+			 &mode_set_byte);
+		orb.cpa = __pa32(&ccw_program.compress);
+		break;
+	default:
+	case 0x3480:
+		orb.cpa = __pa32(&ccw_program.write);
+		break;
+	}
+}
+
+/*
+ * Print message on tape display
+ */
+static void ccw_load_display(const char *msg)
+{
+	char _msg[24] = {0x20};
+
+	strcpy(&_msg[1], msg);
+	start_ccw(LOAD_DISPLAY, CCW_FLAG_SLI, 0x11, (void *) _msg);
+}
+
+/*
+ * Write sense data to buffer
+ */
+static void sense(void *sense_data)
+{
+	start_ccw(SENSE_OVERRUN, CCW_FLAG_SLI, 0x20, sense_data);
+}
+
+/*
+ * Write tape mark at current tape position
+ */
+static void ccw_write_tapemark(void)
+{
+	start_ccw(WRITETAPEMARK, CCW_FLAG_SLI, 0x1, NULL);
+}
+
+/*
+ * Write buffer at current tape position
+ */
+static void ccw_write_block(unsigned long addr, unsigned long size,
+			    unsigned long zero_page)
+{
+	struct scsw *scsw = (struct scsw *) &irb;
+	unsigned long code;
+
+	create_ida_list(ccw_program.ida_list, size, addr, zero_page);
+	ccw_init(&ccw_program.write, WRITE_CMD, CCW_FLAG_SLI | CCW_FLAG_IDA,
+		 size, ccw_program.ida_list);
+	orb.cpa = __pa32(&ccw_program.write);
+	start_io(IPL_SC, &irb, &orb);
+
+	if (scsw->dstat & 0xd2) {
+		/* Something went wrong */
+		sense(ccw_data);
+		code = ccw_data[3]; /* ERA */
+		code = ETAPE_WRITE | (code << 24);
+		panic(code, "I/O Error: RC=%08x", code);
+	}
+	if (scsw->dstat & 0x01) /* Unit exception, end of tape */
+		panic(EMEM, "Device too small");
+}
+
+/*
+ * Every 16 MB we update the tape display
+ */
+static void progress_print_disp(unsigned long addr)
+{
+	char msg[24];
+
+	if (addr % (1024 * 1024 * 16) != 0)
+		return;
+	sprintf(msg, "%08u", addr >> 20);
+	ccw_load_display(msg);
+}
+
+/*
+ * Dump all memory to tape
+ */
+void dt_dump_mem(void)
+{
+	unsigned long addr, page;
+
+	page = get_zeroed_page();
+	setup_idrc_compression();
+	ccw_write_tapemark();
+
+	ccw_write_block((unsigned long) dump_hdr, DF_S390_HDR_SIZE, 0);
+	for (addr = 0; addr < dump_hdr->mem_size; addr += BLK_SIZE) {
+		ccw_write_block(addr, BLK_SIZE, page);
+		progress_print(addr);
+		progress_print_disp(addr);
+	}
+	progress_print(addr);
+	df_s390_em_page_init(page);
+	ccw_write_block(page, sizeof(struct df_s390_em), 0);
+	free_page(page);
+	ccw_write_tapemark();
+	ccw_load_display("DUMP*END");
+}
